

/** INF100, ving 6, oppgave 5.4
   Denne klassen representerer en spiller i det enkle kortspillet
   vrt. Denne spilleren dirigeres av brukeren av programmet via
   terminalen.
*/
public class Spiller
{
    
    /**
       Hver spiller fr tildelt ett kort. Denne variabelen tar vare
       p referansen til kortet spilleren fikk tildelt.
    */
    private Kort kortet;
    
    /**
       Hver spiller i kortspillet m ha et navn.
    */
    private String navnet;
    
    /**
       Oppretter et nytt spiller-objekt. Siden det er brukeren som skal
       dirigere denne spilleren, s m brukeren f bestemme navnet p
       spilleren. Dette gjres ved  sprre brukeren om navnet p
       spilleren via terminalen.
    */
    public Spiller() 
    {
    /*
      Spilleren har ingen kort fr han fr tildelt kortet sitt.
      Kortreferansen "kortet" refererer alts ikke til noe kort
      objekt, dvs. kortet=null. Dette er standardverdien til
      instansevariabler av typen referanse, men vi setter
      referansen her eksplisitt til null for at det skal vre
      lettere  se hva programmet gjr.
    */
        kortet = null;
        
    // N m vi sprre brukeren om navnet p spilleren.
        System.out.print( "Skriv inn navn p ny spiller: " );
        navnet = Terminal.lesString();    
    }
    
    /** Returnerer navnet til spilleren. */
    public String hentNavn() 
    {
        return navnet;
    }
    
    /** Returnerer kortet spilleren har. */
    public Kort hentKort()
    {
    /*
      Vi kunne f.eks. latt denne metoden returnere navnet p
      kortet isteden, dvs return kortet.hentNavn(), siden
      det er som oftest det man er interresert i. Men ved
       returnere en referanse til selve kort-objektet, lar man
      den som kaller metoden bestemme hva kort-objektet skal
      brukes til. Dette gir oss strre fleksibilitet.
    */
        return kortet;
    }

    /**
       Gir spilleren et bestemt kort. Spilleren kan kun ha et kort
       om gangen, s hvis spilleren har et kort fra fr, s vil det 
       gamle kortet bli glemt.
    */
    public void settKort( Kort nyttKort ) 
    {
        kortet = nyttKort;
    // Referansen til et evnt. gammelt kort vil her bli glemt.
    }
    
    /**
       Spr spilleren om han/hun nsker  bytte kort. Returnerer sant
       hvis spilleren nsker  bytte, usant hvis ikke. Siden det
       er brukeren av programmet som skal dirigere denne spilleren
       via terminalen, s spr vi brukeren hva spilleren nsker  gjre.
    */
    public boolean nskerBytteKort() 
    {
    // Brukeren m frst f vite hvilket kort spilleren har.
        System.out.println(hentNavn() + ", du har kortet " +
               hentKort().hentNavn() + ".");
        
    // Spr brukeren om spilleren nsker  bytte kort.
        System.out.print("nsker du  bytte kort, " + hentNavn() + " (j/n)? ");
        String svar = Terminal.lesString();

    boolean fortsett = false;
    
    do
    {
        switch ( svar.charAt(0) ) 
        {
        case 'j': // Vi godtar bde liten og stor bokstav
        case 'J': 
            return true;
        case 'n':
        case 'N':
            return false;
        default:
            System.out.println("Du skrev noe annet enn (j)a eller (n)ei");
            System.out.print("Skriv p nytt (j/n)> ");
            svar = Terminal.lesString();
            fortsett = true;
        }
        
    } while (fortsett);
    return false; // Merk at kontrol aldri nr here
    }
}
